OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- File List
- Globals

Enumerations | Functions
heightmap.h File Reference

Functions related to creating heightmaps from files. More...

`#include "fileio_type.h"`

Go to the source code of this file.

## Enumerations
enum | HeightmapRotation { HM_COUNTER_CLOCKWISE, HM_CLOCKWISE }
| Order of these enums has to be the same as in lang/english.txt Otherwise you will get inconsistent behaviour. More...

## Functions
bool | GetHeightmapDimensions (DetailedFileType dft, const char *filename, uint *x, uint *y)
| Get the dimensions of a heightmap.
void | LoadHeightmap (DetailedFileType dft, const char *filename)
| Load a heightmap from file and change the map in his current dimensions to a landscape representing the heightmap.
void | FlatEmptyWorld (byte tile_height)
| Make an empty world where all tiles are of height 'tile_height'.
void | FixSlopes ()
| This function takes care of the fact that land in OpenTTD can never differ more than 1 in height.

## Detailed Description

Functions related to creating heightmaps from files.

Definition in file heightmap.h.

## Enumeration Type Documentation

enum HeightmapRotation

Order of these enums has to be the same as in lang/english.txt Otherwise you will get inconsistent behaviour.

Enumerator:

  HM_COUNTER_CLOCKWISE | Rotate the map counter clockwise 45 degrees.
  HM_CLOCKWISE | Rotate the map clockwise 45 degrees.

Definition at line 21 of file heightmap.h.

## Function Documentation

void FlatEmptyWorld | ( | byte | tile_height | ) |

Make an empty world where all tiles are of height 'tile_height'.

Parameters

  tile_height | of the desired new empty world

Definition at line 512 of file heightmap.cpp.

References _settings_game, GameSettings::construction, FixSlopes(), ConstructionSettings::freeform_edges, MapSizeX(), MapSizeY(), MarkWholeScreenDirty(), SetTileHeight(), and TileXY().

Referenced by _GenerateWorld().

bool GetHeightmapDimensions | ( | DetailedFileType | dft,
|  | const char * | filename,
|  | uint * | x,
|  | uint * | y
| ) |  |

Get the dimensions of a heightmap.

Parameters

  dft | Type of image file.
  filename | to query
  x | dimension x
  y | dimension y

Returns
  Returns false if loading of the image failed.

Definition at line 479 of file heightmap.cpp.

References ReadHeightMap().

void LoadHeightmap | ( | DetailedFileType | dft,
|  | const char * | filename
| ) |  |

Load a heightmap from file and change the map in his current dimensions to a landscape representing the heightmap.

It converts pixels to height. The brighter, the higher.

Parameters

  dft | Type of image file.
  filename | of the heightmap file to be imported

Definition at line 491 of file heightmap.cpp.

References FixSlopes(), free(), GrayscaleToMapHeights(), MarkWholeScreenDirty(), and ReadHeightMap().

Referenced by GenerateLandscape().